{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends "_layout.html.twig" %}
{% import ('_includes/macros.html.twig') as appMacros %}
{% block title %}Flux en production{% endblock %}
{% set _breadcrumb = ['Flux', 'Flux en production'] %}

{% set is_admin = is_granted('ROLE_ADMIN') %}

{% block content %}
  <!-- Content Header (Page header) -->
  <section class="content-header">
    {% if is_granted('flux.create', app.user) %}
      <a href="{{ path('flux.create') }}"
         data-toggle="modal-remote"
         class="btn btn-primary pull-right"
      >
        <span class="fa fa-rss"></span> &nbsp;Nouveau flux
      </a>
    {% endif %}
    <h1>Flux en production</h1>
  </section>
  <section class="content">
    <!-- /.row -->
    <div class="row">
      <div class="col-xs-12">
        <div class="box">
          <div class="box-body no-padding">
            {{ form_start(list.form, { 'action': app.request.pathInfo, 'method': 'GET' }) }}
            <table class="table table-responsive table-hover m-b-0">
              <thead>
              <tr>
                {{ knp_pagination_sortable(list.pagination, 'Flux', 'flux.name') }}
                {% if is_admin %}
                  {{ knp_pagination_sortable(list.pagination, 'Structure', 'org.name') }}
                {% endif %}
                {{ knp_pagination_sortable(list.pagination, 'Statut', 'status') }}
                {{ knp_pagination_sortable(list.pagination, 'Jeu de règles', 'has_pending_revision') }}
                {{ knp_pagination_sortable(list.pagination, 'Dernier traitement', 'last_process_date') }}
                {{ knp_pagination_sortable(list.pagination, 'POI', 'nb_rdf_resources') }}
              </tr>
              </thead>
              <tbody>
              <tr class="table-filters">
                <td>{{ form_widget(list.form.name, { 'attr': { 'class': 'input-sm' } }) }}</td>
                {% if is_admin %}
                  <td>{{ form_widget(list.form.organization, { 'attr': { 'class': 'input-sm' } }) }}</td>
                {% endif %}
                <td>{{ form_widget(list.form.status, { 'attr': { 'class': 'input-sm' } }) }}</td>
                <td>{{ form_widget(list.form.ruleset, { 'attr': { 'class': 'input-sm' } }) }}</td>
                <td>{{ form_widget(list.form.last_process_date, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
                <td>{{ form_widget(list.form.nb_rdf_resources, { 'attr': { 'class': 'input-sm', 'disabled': true } }) }}</td>
              </tr>
              {% for item in items %}
                {% set flux = item.0 %}
                <tr>
                  <td>
                    <a href="{{ path('flux.detail', {id: flux.id}) }}">{{ flux.name }}</a>
                  </td>
                  {% if is_admin %}
                    <td>
                      <a href="{{ path('organization.edit', { id: flux.organization.id }) }}">
                        {{ flux.organization.name }}
                      </a>
                    </td>
                  {% endif %}
                  <td>
                    {{ appMacros.flux_status_frame(flux.statusInfos.status,
                                                   flux.statusInfos.label,
                                                   flux.statusInfos.description)
                    }}
                    {% if item.last_process_id and
                          flux.lastProcess.statsProduceRDF and
                          flux.lastProcess.statsProduceRDF.anomalies and
                          flux.lastProcess.statsProduceRDF.anomalies.total > 0
                    %}
                      <a href="#">
                        <span class="text-orange pull-right _tooltip"
                              data-tooltip='{"side":"left"}'
                              title="Le flux a rencontré des erreurs non bloquantes
                                     pouvant empêcher la mise à jour de certains POI."
                        >
                          <span class="fa fa-warning"></span>
                        </span>
                      </a>
                    {% endif %}
                  </td>
                  <td>
                    {% set revisionStatus = item.has_pending_revision ? 'pending' : 'active' %}
                    <span class="_tooltip label label-ruleset status-{{ revisionStatus }} "
                          data-tooltip='{"side":"bottom"}'
                          title="{{ revision_status_definitions[revisionStatus][1] }}"
                    >
                      <i class="fa"></i>&nbsp;&nbsp;{{ revision_status_definitions[revisionStatus][0] }}
                    </span>
                  </td>
                  <td>
                    {% if item.last_process_id %}
                      <span data-tooltip='{"side":"right"}' title="{{ item.last_process_date | localizeddate }}">
                        {{ (item.last_process_date | moment).calendar() | capitalize }}
                      </span>
                    {% else %}
                      -
                    {% endif %}
                  </td>
                  <td>
                    <span class="pull-right">{{ item.nb_rdf_resources > 0 ? item.nb_rdf_resources | number_format : '-' }}</span>
                    <span data-frameloader="{{ path('flux.sparkline', {'id': flux.id, 'maxDays': 10}) }}"
                        data-interval="300000">
                    </span>
                </tr>
              {% endfor %}
              </tbody>
            </table>
            {{ form_end(list.form) }}
          </div>

          {% if list.pagination | length == 0 %}
            <div class="blankslate blankslate-spacious">
              <h3>Aucun flux ne correspond à votre recherche.</h3>
            </div>
          {% endif %}

          {% if is_granted('ROLE_ADMIN', app.user) or list.totalItemCount > page_size %}
            <div class="box-footer">
                {% if is_granted('ROLE_ADMIN', app.user) %}
                  <a href="{{ path('flux.production.export', app.request.query.all) }}" class="btn btn-default btn-sm pull-left">
                    <span class="fa fa-download"></span> Télécharger la liste
                  </a>
                {% endif %}
              {{ knp_pagination_render(list.pagination, null, [], {class: "pagination-sm no-margin pull-right"}) }}
            </div>
          {% endif %}
        </div>
      </div>
    </div>
  </section>
{% endblock %}